{$APPTYPE CONSOLE}
	Uses testlib, SysUtils;
	Const
		MaxN = 50;
		MaxK = 50;
		Eps = 1.1E-3;
		Eps2 = 1E-9;
	Type Real = Extended;
	Var 
		I, N, K : LongInt;
		S : Array[1..MaxN] Of Real;
		V : Array[1..MaxK] Of LongInt;
		Time : Array [1..MaxN] Of Real;
		Project : Array [1..MaxK] Of LongInt;
		Firm : Array [1..MaxN] Of LongInt;
		OutAns, Answer, LastT : Real;

Procedure DoProject;
	Var
		T : Real;
		ObjectID, FirmID, I : LongInt;

Begin
	T := ouf.ReadReal;
	If (LastT > T + Eps2) Then Begin
		Quit(_WA, 'ୠ ஭. ᫥ ᮡ   ' + FloatToStr(LastT) + '  ᮡ⨥   ' + FloatToStr(T));
	End;
	If (T > OutAns + Eps) Then Begin
	    Quit(_WA, '砫 ந⥫⢠ ᫥ ६ T: ' + FloatToStr(T) + ' > ' + FloatToStr(OutAns));
	End;
	LastT :=T;
	ObjectID := ouf.ReadLongInt;
	FirmID := ouf.ReadLongInt;
	If (FirmID <=0) Or (FirmID > K) Then Begin
		Quit(_WA, '४  : ' + IntToStr(FirmID));
	End;
	If (ObjectID <=0) Or (ObjectID > N) Then Begin
		Quit(_WA, '४  ꥪ: ' + IntToStr(ObjectID));
	End;
//	WriteLn(T:0:2,' ',ObjectID,' ',FirmID);
	If (Firm[ObjectID] > 0) Then Begin
		Project[Firm[ObjectID]] := 0;
		S[ObjectID] := S[ObjectID] - V[Firm[ObjectID]] * (T - Time[ObjectID]);
	End;
	If (Project[FirmID] > 0) Then Begin
		S[Project[FirmID]] := S[Project[FirmID]] - V[FirmID] * (T - Time[Project[FirmID]]);
		Firm[Project[FirmID]] := 0;
		Time[Project[FirmID]] := T;
	End;
	Firm[ObjectID] := FirmID;
	Time[ObjectID] := T;
	Project[FirmID] := ObjectID;
	//S[ObjectId] := S[ObjectID] - V[FirmID] * T;
//	For I := 1 To N Do Begin
//		If (S[I] < -Eps) Then
//			Quit(_WA, '誮  ६ 祭  믮 ஥ ' + IntToStr(I));
//		Write(S[I]:0:2,' ');
//	End;
//	WriteLn;
	//Time[FirmID] := Time[FirmID] + T;
	//If (Time[FirmID] > )
End;

Begin
	LastT := 0;
	N := inf.ReadLongInt();
	For I := 1 To N Do Begin
		S[I] := inf.ReadLongInt();
		Time[I] :=0;
		Firm[I] :=0;
	End;
	K := inf.ReadLongInt();
	For I :=1 To K Do Begin
		V[I] := inf.ReadLongInt();
		Project[I] := 0;
	End;
	Answer := ans.ReadReal();
	OutAns := ouf.ReadReal();

	While Not ouf.SeekEoF Do Begin
		DoProject;
	End;

	For I := 1 To N Do Begin
		If (Firm[I] > 0) Then Begin
			S[I] := S[I] - V[Firm[I]] * (OutAns + Eps - Time[I]);
			Time[I] := OutAns;
		End;
//		If (S[I] < -Eps) Then
//			Quit(_WA, '誮  ६ 祭  믮 ஥ ' + IntToStr(I));
		If (S[I] > Eps) Then
			Quit(_WA, ' ஥ ' + IntToStr(I) + ' ᢮ ' + FloatToStr(S[I]) + ' . .');
	End;

	If (Answer > OutAns + Eps) Then Begin
		Quit(_FAIL, ' 室 䠩 㪠  ⨬ ⢥.  ' + FloatToStr(Answer) + '  襭  ६ ' + FloatToStr(OutAns));
	End;
	If (Answer + Eps  < OutAns) Then Begin
		Quit(_WA, '⨬쭮 ६ 砭 ࠡ.  ' + FloatToStr(Answer) + '  ' + FloatToStr(OutAns));
	End;

	Quit(_OK, 'T = ' + FloatToStr(Answer));
End.