import java.io.*;
import java.util.*;


public class olymp_vv{
	
	public class P implements Comparable<P>{
		double l;
		int n;
		
		P(double _l, int _n){
			l = _l; n = _n;
		}
		
		public int compareTo(P p){
			if (l>p.l) return -1;
			if (l<p.l) return 1;
			return 0;
		}
	}
	
	public double gettime(double[] s, double[] e){
		double max = 0;
		double ss = 0;
		for(int i = 0;i<s.length;i++){
			ss+=s[s.length - 1 - i];
			max = Math.max(max,ss*e[i]);
		}
		return max;
	}
	
	Scanner in;
	PrintWriter out;
	
	double EPS1 = 1e-15;
	double EPS2 = 1e-9;
	int MAX = 40;
	
	public void run() throws Exception{
		in = new Scanner(new File("olymp.in"));
		out = new PrintWriter(new FileWriter(new File("olymp.out")));
		int n = in.nextInt();
		P[] s = new P[n];
		for(int i = 0;i<n;i++)
			s[i] = new P(in.nextDouble(),i);
		Arrays.sort(s);
		int k = in.nextInt();
		P[] w = new P[Math.max(k,n)];
		for(int i = 0;i<k;i++){
			w[i] = new P( in.nextDouble(),i);
		}
		for(int i = k;i<n;i++) w[i] = new P(0,0);
		Arrays.sort(w);
		double[] e = new double[n];
		double tt = 0;
		for(int i = 0; i<n;i++){
			tt+=w[i].l;
			e[i] = 1/tt;
		}
		double[] ss = new double[n];
		for(int i = 0;i<n;i++)
			ss[i] = s[i].l;
		Arrays.sort(ss);
		double t = gettime(ss,e);
		out.println(t);
		int[] q = new int[n];
		double cur = 0;
		while (t>EPS1){
			for(int i = 0; i<n;i++) if (i<k){
				out.println(cur+" "+(s[i].n+1)+" "+(w[i].n+1));
			}
			double r = t;
			double l = 0;
			for(int i = 0;i<MAX;i++){
				double x = (r+l)*0.5;
				for(int j = 0;j<n;j++)
					ss[j] = Math.max(0,s[j].l-x*w[j].l);
				Arrays.sort(ss);
				if (gettime(ss,e)+x<=t+EPS2) l = x;
				else r = x; 
			}
			for(int i = 0; i<n;i++){
				s[i].l-=l*w[i].l;
			}
			Arrays.sort(s);
			for(int j = 0;j<n;j++)
				ss[j] = Math.max(0,s[j].l);
			Arrays.sort(ss);		
			double tt2 = gettime(ss,e);	
			cur+=(t-tt2);
			t = tt2;
		}
		out.close();
	}
	public static void main(String[] args) throws Exception{
		new olymp_vv().run();
	}
}